.TH vitobs 1 "13 Jan 2013"
.SH NAME
vitobs \- convert implicit-style Verilog to one-hot simulation on a BasicStamp chip
.SH SYNOPSIS
.B vitobs
.BI file
.SH DESCRIPTION
.B vitobs 
reads 
.I file\^.v
in sequence
and converts any implicit style always blocks into one-hot style BasicStamp code.
The BasicStamp output is sent to file.bs2.
Thus,
.B vitobs
cannot be used as a filter (unlike other VITO tools).
See
http://www.verilogvito.com/vitobasic.html web page for more information.
.SH OPERANDS
The following operand is supported:
.TP 8
.I file
A path name of an input file without an extension. 
.B vitobs 
reads file.v, file.bs0 and file.bs1 as inputs
and produces file.bs2, which can be downloaded to a BasicStamp chip.
.SH EXAMPLES
.TP 3
1.
There is an examples subdirectory.  In this, the  following command:
.LP
.RS
.B "examples% ../vitobs charlibounce12"
.RE
.LP
.RS 3
converts any implicit style modules in
.B charlibounce12.v
into one-hot style (using BasicStamp files 
.B charlibounce12.bs0 
and 
.B charlibounce12.bs1
) and
writes the results
to 
.B charlibounce12.bs2.
.SH ENVIRONMENT
.B vitobs
reads the file
.BI .vitorc
for initialization each time it is started.
This file contains the names of files to use for debugging output,
the identifier names for new wires and regs, and the names of
preexisting identifiers.
This file is searched for in the current directory only.
If it is not found, a set of default values are used.
See the web pages for more information.
.SH "EXIT STATUS"
The following exit values are returned:
.TP 4
.B 0
All input files were converted successfully.
.TP
.B >0
An error occurred.
.SH NOTES
