/*****************************************************************************
*                                                                            *
*     VITO -- Verilog Implicit To One-hot translator                         *
*     $Id: legal.txt,v 1.7 1999/06/03 15:24:08 mwinkel Apr_19_2004_Version_1.5 $
*                                                                            *
*     This software translates implicit style Verilog into a form suitable   *
*     for most commercial synthesis tools.  The translation is achieved      *
*     by constructing a one-hot machine for the ASM described in the         *
*     implicit style Verilog.                                                *
*                                                                            *
*     This work is being performed at the University of Wyoming and SUNY     *
*     College at Brockport.  For more information:                           *
*	   www.verilog.vito.com                                              *
*          http://strawberry.uwyo.edu/~vito                                  *
*          http://cs.brockport.edu/~jshuler/vito                             *
*                                                                            *
*     Authors:                                                               *
*          James D. Shuler  jshuler@cs.brockport.edu                         *
*          Mark G. Arnold   marnold@uwyo.edu                                 *
*                                                                            *
*                         NOTICE AND DISCLAIMER                              *
*                                                                            *
* No use of this software is authorized except under this NOTICE AND         *
* DISCLAIMER.  Downloading, use, copying, modification, and/or               *
* distribution of this software in its original or modified form implies     *
* your acceptance of this NOTICE and DISCLAIMER.                             *
*                                                                            *
* Permission to use, copy, modify and distribute this software and its       *
* documentation, for any purpose and without fee is hereby granted,          *
* provided that this permission notice appears prominently in supporting     *
* documentation and must be viewed prior to use, copying, modification or    *
* distribution.  You are responsible for any modifications to the software   *
* which you make and notice that the software has been modified must be      *
* appended to this notice prior to further use, copying, modification or     *
* distribution.                                                              *
*                                                                            *
* This software is provided AS IS without warranty of any kind,              *
* including without limitation the warranties that the software is           *
* non-infringing, merchantable, or fit for a particular purpose, including   *
* high risk activities.  The entire risk as to the quality and performance   *
* of the software is born by you.  Should the software prove defective in    *
* any respect, you and not the developers, nor any parties associated with   *
* the developers, assume the entire cost of  any service and repair.         *
*                                                                            *
* This software may be subject to the Export Control Laws of the United      *
* States of America.  It is your responsibility to determine the             *
* applicable laws and regulations and comply with them.                      *
*                                                                            *
*****************************************************************************/
%{
/*****************************************************************************
$Id: vitop.y,v 1.6 1999/06/03 17:08:35 mwinkel Apr_19_2004_Version_1.5 $

	VITO parser using YACC.  Only a subset of the Verilog langauge is
   supported.

*****************************************************************************/
#include "vito.h"
%}

%token XALWAYS
%token XAND
%token XASSIGN
%token XBEGIN
%token XBUF
%token XBUFIF0
%token XBUFIF1
%token XCASE
%token XCASEX
%token XCASEZ
%token XCMOS
%token XDEASSIGN
%token XDEFAULT
%token XDEFPARAM
%token XDISABLE
%token XEDGE
%token XELSE
%token XEND
%token XENDCASE
%token XENDFUNCTION
%token XENDMODULE
%token XENDPRIMITIVE
%token XENSPECIFY
%token XENDTABLE
%token XENDTASK
%token XEVENT
%token XFOR
%token XFORCE
%token XFOREVER
%token XFORK
%token XFUNCTION
%token XHIGHZ0
%token XHIGHZ1
%token XIF
%token XINITIAL
%token XINOUT
%token XINPUT
%token XINTEGER
%token XJOIN
%token XLARGE
%token XMACROMODULE
%token XMEDIUM
%token XMODULE
%token XNAND
%token XNEGEDGE
%token XNMOS
%token XNOR
%token XNOT
%token XNOTIF0
%token XNOTIF1
%token XOR
%token XOUTPUT
%token XPARAMETER
%token XPMOS
%token XPOSEDGE
%token XPRIMITIVE
%token XPULL0
%token XPULL1
%token XPULLDOWN
%token XPULLUP
%token XRCMOS
%token XREAL
%token XREALTIME
%token XREG
%token XRELEASE
%token XREPEAT
%token XRNMOS
%token XRPMOS
%token XRTRAN
%token XRTRANIF0
%token XRTRANIF1
%token XSCALARED
%token XSMALL
%token XSPECIFY
%token XSPECPARAM
%token XSTRONG0
%token XSTRONG1
%token XSUPPLY0
%token XSUPPLY1
%token XTABLE
%token XTASK
%token XTIME
%token XTRAN
%token XTRANIF0
%token XTRANIF1
%token XTRI
%token XTRI0
%token XTRI1
%token XTRIAND
%token XTRIOR
%token XTRIREG
%token XVECTORED
%token XWAIT
%token XWAND
%token XWEAK0
%token XWEAK1
%token XWHILE
%token XWIRE
%token XWOR
%token XXNOR
%token XXOR

%token XLBRACKET
%token XRBRACKET
%token XCOMMA
%token XPLUS
%token XMINUS
%token XMULT
%token XDIVIDE
%token XMOD
%token XGREATER
%token XGREATEREQ
%token XLESS
%token XLESSEQ
%token XLNOT
%token XLAND
%token XLOR
%token XLEQUAL
%token XLNOTEQUAL
%token XCEQUAL
%token XCNOTEQUAL
%token XBNOT
%token XBAND
%token XBNAND
%token XBOR
%token XBNOR
%token XBXOR
%token XBXNOR
%token XLSHIFT
%token XRSHIFT

%token XQUESTION
%token XCOLON
%token XSEMI
%token XLPAREN
%token XRPAREN
%token XLSQUARE
%token XRSQUARE
%token XPOUND
%token XPERIOD
%token XDOLLAR
%token XAT
%token XEQUAL
%token XEVENTTRIGGER

%token XIDENTIFIER
%token XNUMBER
%token XCOMMENT
%token XSTRING

%start source_text

%%
source_text:		{ token_print=PUT_STMT;}
			Mdescription 
			;

Mdescription:		
		|	Mdescription description
		|	error XENDMODULE
			;

description:		{  init_for_module(); }
			module_declaration
			{ post_for_module();}
			;

module_declaration:	{ ts_clear(); }
			module_keyword
			{  /*tp(" ",NULL);*/
			   reset_in_port = FALSE;
			   clock_in_port = FALSE;
			}
			identifier 
   			{  if (verbose_mode)
      			      info("Parsing module '%s'\n",Get_ID($4.identifier));
			   current_module = $4.identifier;}
			Olist_of_ports 
			XSEMI
			{  tp(";",$7.comment);
			   /* Remove since not all modules need have these
			   if (!reset_in_port) {
			      error("Must have '%s' in port list.\n",Get_ID(reset_ID));
			   }
			   if (!clock_in_port) {
			      error("Must have '%s' in port list.\n",Get_ID(clock_ID));
			   }
			   */
			}
			Mmodule_item 
			XENDMODULE 
			{  token_print=PUT_TAIL;
			   tp("endmodule",$10.comment);}
			;

module_keyword:		XMODULE  {tp("module",$1.comment);};

Olist_of_ports:		
		|	list_of_ports
			;

list_of_ports:		XLPAREN  {tp("(",$1.comment);} Mport XRPAREN  {tp(")",$4.comment);};

Mport:			port
		|	Mport XCOMMA  {tp(",",$2.comment);} port
			;

port:			
		|	port_expression
		|	XPERIOD  Print_period identifier XLPAREN  Print_lparen XRPAREN {tp(")",$6.comment);}
		|	XPERIOD  Print_period identifier XLPAREN  Print_lparen port_expression XRPAREN {tp(")",$7.comment);}
			;

Print_period:		{tp(".",$0.comment);} ;
Print_lparen:		{tp("(",$0.comment);} ;

port_expression:	port_reference
		|	XLBRACKET  {tp("{",$1.comment);}Mport_reference XRBRACKET {tp("}",$4.comment);}
			;

Mport_reference:	port_reference
		|	Mport_reference XCOMMA  {tp(",",$2.comment);}port_reference
			;

port_reference:		identifier
			{ /* check to see if this is the reset or clock signal */
			   if ($1.identifier==reset_ID)
			      reset_in_port=TRUE;
			   if ($1.identifier==clock_ID)
			      clock_in_port=TRUE;
			}
		|	identifier XLSQUARE  Print_lsquare constant_expression XRSQUARE {tp("]",$5.comment);}
		|	identifier XLSQUARE  Print_lsquare constant_expression XCOLON  {tp(":",$5.comment);}constant_expression XRSQUARE {tp("]",$8.comment);}
			;

Mmodule_item:		
		|	Mmodule_item {ts_clear();} module_item
			;

module_item:		module_item_declaration
		|	parameter_override
		|	continuous_assign
		|	gate_OR_udp_instantiation {/* Uses Palnitkar grammar */}
		|	module_instantiation
		|	initial_construct
		|	always_construct
		|	error XEND
			;

module_item_declaration:	parameter_declaration
		|	input_declaration
		|	output_declaration
		|	inout_declaration
		|	net_declaration
		|	reg_declaration
		|	integer_declaration
		|	real_declaration
		|	time_declaration
		|	realtime_declaration
		|	event_declaration
		|	task_declaration
		|	function_declaration
		|	error XSEMI
			;

parameter_override:	XDEFPARAM {tp("defparam",$1.comment);} list_of_param_assignments XSEMI {tp(";",$4.comment);}
			;

parameter_declaration:	XPARAMETER 
			{tp("parameter",$1.comment);} 
			Print_space
			list_of_param_assignments 
			XSEMI  
			{tp(";",$5.comment);}
			Print_newline
			;

list_of_param_assignments:	param_assignment
		|	list_of_param_assignments XCOMMA {tp(",",$2.comment);} param_assignment
			;

param_assignment:	identifier XEQUAL {tp("=",$2.comment);} constant_expression ;

input_declaration:	XINPUT {tp("input",$1.comment);} list_of_port_identifiers XSEMI {tp(";",$4.comment);}
		|	XINPUT {tp("input",$1.comment);} range list_of_port_identifiers XSEMI {tp(";",$5.comment);}
			;

output_declaration:	XOUTPUT {tp("output",$1.comment);} list_of_port_identifiers XSEMI {tp(";",$4.comment);}
		|	XOUTPUT {tp("output",$1.comment);} range list_of_port_identifiers XSEMI {tp(";",$5.comment);}
			;

inout_declaration:	XINOUT {tp("inout",$1.comment);} list_of_port_identifiers XSEMI {tp(";",$4.comment);}
		|	XINOUT {tp("inout",$1.comment);} range list_of_port_identifiers XSEMI {tp(";",$5.comment);}
			;

list_of_port_identifiers:	list_of_identifiers ;

reg_setup:		{  tp("reg",$0.comment);
			   if (ai_process)
			      tp(" ",NULL);
			   if (duplicate_regs) {
			      do_new_wire = TRUE;
			      put_arch("wire ");
			      tp_other = PUT_ARCH;
			   }
			}
			;
reg_declaration:	XREG
			reg_setup
			list_of_register_identifiers
			XSEMI
			{
			   tp(";",$4.comment);
			   if (duplicate_regs) {
                              if (do_new_wire)
			         put_arch("\n");
			      do_new_wire = FALSE;
			      tp_other = PUT_NONE;
			   }
			}
			Print_newline
		|	XREG
			reg_setup
			range 
			list_of_register_identifiers
			XSEMI
			{
			   tp(";",$5.comment);
			   if (duplicate_regs) {
                              if (do_new_wire)
			         put_arch("\n");
			      do_new_wire = FALSE;
			      tp_other = PUT_NONE;
			   }
			}
			Print_newline
			;

time_declaration:	XTIME 
			{tp("time",$1.comment);} 
			Print_space
			list_of_register_identifiers 
			XSEMI  
			{tp(";",$5.comment);}
			Print_newline
			;

integer_declaration:	XINTEGER 
			{tp("integer",$1.comment);} 
			Print_space
			list_of_register_identifiers 
			XSEMI 
			{tp(";",$5.comment);}
			Print_newline
			;

real_declaration:	XREAL 
			{tp("real",$1.comment);} 
			Print_space
			list_of_real_identifiers 
			XSEMI 
			{tp(";",$5.comment);}
			Print_newline
			;

realtime_declaration:	XREALTIME 
			{tp("realtime",$1.comment);} 
			Print_space
			list_of_real_identifiers 
			XSEMI 
			{tp(";",$5.comment);}
			Print_newline
			;

event_declaration:	XEVENT 
			{tp("event",$1.comment);} 
			Print_space
			list_of_identifiers 
			XSEMI 
			{tp(";",$5.comment);}
			Print_newline
			;

list_of_real_identifiers:	list_of_identifiers ;

list_of_register_identifiers:	register_name
		|	list_of_register_identifiers XCOMMA {tp(",",$2.comment);} register_name
			;

register_name_setup: {  if (do_new_wire)
			      put_arch(rc_string[NEWWIREPRE]); }
			;

register_name:		register_name_setup
			identifier
		|	register_name_setup
			identifier XLSQUARE {tp("[",$3.comment);} constant_expression XCOLON {tp(":",$6.comment);} constant_expression XRSQUARE {tp("]",$9.comment);}
			;

Orange:
		|	range
			;

range:			XLSQUARE {tp("[",$1.comment);} constant_expression XCOLON {tp(":",$4.comment);}constant_expression XRSQUARE {tp("]",$7.comment);};

net_declaration:	net_type Ovect_scal Orange Odelay3 list_of_net_identifiers XSEMI {tp(";",$6.comment);}
		|	XTRIREG {tp("trireg",$1.comment);} Ovect_scal Ocharge_strength Orange Odelay3 list_of_net_identifiers XSEMI {tp(";",$8.comment);}
		|	net_type Ovect_scal drive_strength Orange Odelay3 list_of_net_decl_assignments XSEMI {tp(";",$7.comment);
		/* there is much more! */}
			;

Ovect_scal:		
		|	XVECTORED {tp("vectored",$1.comment);}
		|	XSCALARED {tp("scalared",$1.comment);}
			;

net_type:		XWIRE {tp("wire",$1.comment);}
		|	XTRI {tp("tri",$1.comment);}
		|	XTRI1 {tp("tri1",$1.comment);}
		|	XSUPPLY0 {tp("supply0",$1.comment);}
		|	XWAND {tp("wand",$1.comment);}
		|	XTRIAND {tp("triand",$1.comment);}
		|	XTRI0 {tp("tri0",$1.comment);}
		|	XSUPPLY1 {tp("supply1",$1.comment);}
		|	XWOR {tp("wor",$1.comment);}
		|	XTRIOR {tp("trior",$1.comment);}
			;

list_of_net_identifiers:list_of_net_decl_assignments ;

Odrive_strength:
		|	drive_strength
			;

drive_strength: 	XLPAREN {tp("(",$1.comment);} drive_strength_np
			;

drive_strength_np:	strength0 XCOMMA {tp(",",$2.comment);} strength1 XRPAREN {tp(")",$5.comment);}
		|	strength1 XCOMMA {tp(",",$2.comment);} strength0 XRPAREN {tp(")",$5.comment);}
			;

strength0:		XSUPPLY0 {tp("supply0",$1.comment);}
		|	XSTRONG0 {tp("strong0",$1.comment);}
		|	XPULL0 {tp("pull0",$1.comment);}
		|	XWEAK0 {tp("weak0",$1.comment);}
		|	XHIGHZ0 {tp("highz0",$1.comment);}
			;

strength1:		XSUPPLY1 {tp("supply1",$1.comment);}
		|	XSTRONG1 {tp("strong1",$1.comment);}
		|	XPULL1 {tp("pull1",$1.comment);}
		|	XWEAK1 {tp("weak1",$1.comment);}
		|	XHIGHZ1 {tp("highz1",$1.comment);}
			;

Ocharge_strength:	
		|	XLPAREN {tp("(",$1.comment);} sml XRPAREN {tp(")",$4.comment);}
			;

sml:			XSMALL {tp("small",$1.comment);}
		|	XMEDIUM {tp("medium",$1.comment);}
		|	XLARGE {tp("large",$1.comment);}
			;

Odelay3:		
		|	delay3
			;

delay3: 		XPOUND {tp("#",$1.comment);} simple_delay_value
		|	XPOUND XLPAREN  Print_poundlp delay_value XRPAREN {tp(")",$5.comment);}
		|	XPOUND XLPAREN Print_poundlp delay_value XCOMMA Print_comma delay_value XRPAREN {tp(")",$8.comment);}
		|	XPOUND XLPAREN Print_poundlp delay_value XCOMMA Print_comma delay_value XCOMMA {tp(",",$8.comment);}delay_value XRPAREN {tp(")",$11.comment);}
			;

Print_poundlp:		{tp("#",$-1.comment);tp("(",$0.comment);} ;
Print_comma:		{tp(",",$0.comment);} ;

simple_delay_value:	unsigned_number
		|	identifier
			;

delay_value:		constant_mintypmax_expression
		  	{/*T&M does not use () which seems wrong due to trouble
		     	with something like:
			  x <= #3+4:5+6:7+8 -9;
			*/}
			;

list_of_net_decl_assignments:	net_decl_assignment
		|	list_of_net_decl_assignments XCOMMA {tp(",",$2.comment);} net_decl_assignment
			;

net_decl_assignment:	identifier
		|	identifier XEQUAL {tp("=",$2.comment);} expression
			;

function_declaration:	XFUNCTION
			{tp("function",$1.comment);}
			range_or_type 
			identifier 
			XSEMI 
			{tp(";",$5.comment); duplicate_regs=FALSE;}
			Mfunction_item_declaration
			{ duplicate_regs=TRUE; }
			statement
			XENDFUNCTION 
			{tp("endfunction",$10.comment);}
			;

range_or_type:
		|	range
		|	XINTEGER {tp("integer",$1.comment);}
		|	XREAL {tp("real",$1.comment);}
		|	XREALTIME {tp("realtime",$1.comment);}
		|	XTIME {tp("time",$1.comment);}
			;

Mfunction_item_declaration:	function_item_declaration
		|	Mfunction_item_declaration function_item_declaration
			;

function_item_declaration:	block_item_declaration
		|	input_declaration
			;

task_declaration:	XTASK {tp("task",$1.comment);} identifier XSEMI {tp(";",$4.comment);}
			Mtask_item_declaration
			statement_or_null
			XENDTASK {tp("endtask",$8.comment);}
			;

Mtask_item_declaration:	
		|	Mtask_item_declaration task_item_declaration
			;

task_item_declaration:	block_item_declaration
		|	output_declaration
		|	inout_declaration
			;

Mblock_item_declaration:
		|	Mblock_item_declaration block_item_declaration
			;

block_item_declaration:	parameter_declaration
		|	reg_declaration
		|	integer_declaration
		|	real_declaration
		|	time_declaration
		|	realtime_declaration
		|	event_declaration
			;

gate_OR_udp_instantiation:	gatetype XLPAREN {tp("(",$2.comment);} Mterminal XRPAREN {tp(")",$5.comment);}
			Mgate_instance2 XSEMI {tp(";",$8.comment);}
		|	gatetype delay3 XLPAREN {tp("(",$3.comment);} Mterminal XRPAREN {tp(")",$6.comment);}
			Mgate_instance2 XSEMI {tp(";",$9.comment);}
		|	gatetype XLPAREN {tp("(",$2.comment);} drive_strength_np Odelay3 Mgate_instance3 XSEMI {tp(";",$7.comment);}
		|	gatetype Odelay3 Mgate_instance XSEMI {tp(";",$4.comment);}
			;
gatetype:		XAND {tp("and",$1.comment);}
		|	XNAND {tp("nand",$1.comment);}
		|	XOR {tp("or",$1.comment);}
		|	XNOR {tp("nor",$1.comment);}
		|	XXOR {tp("xor",$1.comment);}
		|	XXNOR {tp("xnor",$1.comment);}
		|	XBUF {tp("buf",$1.comment);}
		|	XBUFIF0 {tp("bufif0",$1.comment);}
		|	XBUFIF1 {tp("bufif1",$1.comment);}
		|	XNOT {tp("not",$1.comment);}
		|	XNOTIF0 {tp("notif0",$1.comment);}
		|	XNOTIF1 {tp("notif1",$1.comment);}
		|	XPULLDOWN {tp("pulldown",$1.comment);}
		|	XPULLUP {tp("pullup",$1.comment);}
		|	XNMOS {tp("nmos",$1.comment);}
		|	XRNMOS {tp("rnmos",$1.comment);}
		|	XPMOS {tp("pmos",$1.comment);}
		|	XRPMOS {tp("rpmos",$1.comment);}
		|	XCMOS {tp("cmos",$1.comment);}
		|	XRCMOS {tp("rcmos",$1.comment);}
		|	XTRAN {tp("tran",$1.comment);}
		|	XRTRAN {tp("rtran",$1.comment);}
		|	XTRANIF0 {tp("tranif0",$1.comment);}
		|	XRTRANIF0 {tp("rtranif0",$1.comment);}
		|	XTRANIF1 {tp("tranif1",$1.comment);}
		|	XRTRANIF1 {tp("rtranif1",$1.comment);/*}
		Removed since causes ambiguous grammar
		|	identifier {/* for UDPs--quick and dirty solution}
		|	identifier range {/* for UDPs--quick and dirty solution*/}
			;


Mgate_instance:		gate_instance
		|	Mgate_instance XCOMMA {tp(",",$2.comment);} gate_instance
			;

Mgate_instance2:	
		|	Mgate_instance2 XCOMMA {tp(",",$2.comment);} gate_instance3
			;

Mgate_instance3:	gate_instance3
		|	Mgate_instance3 XCOMMA {tp(",",$2.comment);} gate_instance3
			;

gate_instance:		name_of_gate_instance XLPAREN {tp("(",$2.comment);} Mterminal XRPAREN {tp(")",$5.comment);}
			;

gate_instance3:		Oname_of_gate_instance XLPAREN {tp("(",$2.comment);} Mterminal XRPAREN {tp(")",$5.comment);}
			;

Oname_of_gate_instance:	
		|	name_of_gate_instance
			;

name_of_gate_instance:	identifier
		|	identifier range
			;

Mterminal:		terminal
		|	Mterminal XCOMMA {tp(",",$2.comment);} terminal
			;

terminal:		expression
			;

module_instantiation:	identifier Oparameter_value_assignment Mmodule_instance XSEMI {tp(";",$4.comment);}
			;

Oparameter_value_assignment:
		|	XPOUND 
			{tp("#",$1.comment);} 
			XLPAREN
			{tp("(",$3.comment);}
			Mexpression
			XRPAREN
			{tp(")",$6.comment);}
			;

Mmodule_instance:	module_instance
		|	Mmodule_instance XCOMMA {tp(",",$2.comment);} module_instance
			;

module_instance:	name_of_instance XLPAREN {tp("(",$2.comment);} list_of_module_connections XRPAREN {tp(")",$5.comment);}
			;

name_of_instance:	identifier
		|	identifier range
			;

list_of_module_connections: 	Mordered_port_connection
		|	Mnamed_port_connection
			;

Mordered_port_connection:	ordered_port_connection
		|	Mordered_port_connection XCOMMA {tp(",",$2.comment);} ordered_port_connection
			;

ordered_port_connection:	
		|	expression
			;

Mnamed_port_connection:	named_port_connection
		|	Mnamed_port_connection XCOMMA {tp(",",$2.comment);} named_port_connection
			;

named_port_connection:	XPERIOD
			{tp(".",$1.comment);} 
			identifier 
			XLPAREN 
			{tp("(",$4.comment);}
			Oexpression
			XRPAREN
			{tp(")",$7.comment);}
			;

continuous_assign:	XASSIGN {tp("assign",$1.comment);} Odrive_strength Odelay3 list_of_net_assignments XSEMI {tp(";",$6.comment);}
			;

list_of_net_assignments:	net_assignment
		|	list_of_net_assignments XCOMMA {tp(",",$2.comment);} net_assignment
			;

net_assignment:		net_lvalue XEQUAL {tp("=",$2.comment);} expression
			;

initial_construct:	{ ts_clear(); }
			XINITIAL
			{
			   tp("",$2.comment);
			   initial_begin=TRUE;
			}
			statement
			{
			   if (ai_process) {
			      tp("end\n",NULL);
			      token_print=PUT_STMT;
			      ai_process=FALSE;
			      ignore_comments=FALSE; 
			   }
			}
			;

always_construct:	{ /*ignore_comments=TRUE;*/ ts_clear(); }
			XALWAYS
			{
			   tp("",$2.comment);
			   always_begin=TRUE;
			}
			statement
			{
			   if (ai_process) {
			      tp("end\n",NULL);
			      token_print=PUT_STMT;
			      ai_process=FALSE;
			      ignore_comments=FALSE; 
			   }
			}
			;

Mstatement:
		|	Mstatement statement
			;

statement:		Print_newline Begin_check blocking_assignment XSEMI {tp(";",$4.comment);} Print_newline
		|	Print_newline Begin_check non_blocking_assignment XSEMI {tp(";",$4.comment);} Print_newline
		|	Print_newline Begin_check procedural_continuous_assignment XSEMI {tp(";",$4.comment);} Print_newline
		|	Begin_check procedural_timing_control_statement
		|	Print_newline Begin_check conditional_statement
		|	Print_newline Begin_check case_statement
		|	Print_newline Begin_check loop_statement
		|	Print_newline Begin_check wait_statement
		|	Print_newline Begin_check disable_statement
		|	Print_newline Begin_check event_trigger
		|	Print_newline {/*tp("\n",NULL);*/
			   ts_clear();
			   if (always_begin) {
			      token_print=PUT_OUT;
			      ai_process=TRUE;
			      implicit_module = TRUE;
			      tp("always\nbegin\n",NULL);
			      ignore_comments=TRUE;
			   }
			   if (initial_begin) {
			      tp("initial",NULL);/* removed newline */
			      /* do not accept initial for ASM
			      token_print=PUT_OUT;
			      ai_process=TRUE;
			      implicit_module = TRUE;
			      tp("initial\nbegin\n",NULL);
			      ignore_comments=TRUE;
			      */
			   }
			   initial_begin=FALSE;
			   always_begin=FALSE;
			} seq_block
		|	Print_newline Begin_check par_block
		|	Print_newline Begin_check task_enable
		|	Print_newline Begin_check system_task_enable
		|	error XSEMI
			;

Print_newline:		{ if (ai_process)
			     tp("\n",NULL); } ;

Print_space:		{ if (ai_process)
			     tp(" ",NULL); } ;

Begin_check:		{  ts_clear();
			   /* delay printing always since don't know which file to put it
			      into until a begin is found after it */
			   if (always_begin) {
			      tp("always",NULL);
			      if (ai_process)
				 tp("\n",NULL);
			   }
			   if (initial_begin) {
			      tp("initial",NULL);
			      if (ai_process)
				 tp("\n",NULL);
			   }
			   initial_begin=FALSE;
			   always_begin=FALSE;
			}

statement_or_null:	statement
		|	XSEMI { tp(";",$1.comment); }
			Print_newline
			;

blocking_assignment:	reg_lvalue XEQUAL {tp("=",$2.comment);vito_check("blocking assignment");} expression
		|	reg_lvalue XEQUAL {tp("=",$2.comment);vito_check("blocking assignment");} delay_or_event_control {if (ai_process) tp(" ",NULL);} expression
			;

non_blocking_assignment:reg_lvalue XLESSEQ
			{  tp("<=",$2.comment);
			   if (ai_process){
			      tp(rc_string[ATEVENT],NULL);
			      tp(" ",NULL);
			   }
			} expression
		|	reg_lvalue XLESSEQ {tp("<=",$2.comment);} delay_or_event_control {if (ai_process) tp(" ",NULL);} expression
			;

procedural_continuous_assignment:	XASSIGN {vito_check("procedural assign");tp("assign",$1.comment);} Print_space reg_assignment 
		|	XDEASSIGN {vito_check("deassign");tp("deassign",$1.comment);} Print_space reg_lvalue
		|	XFORCE {vito_check("force");tp("force",$1.comment);} Print_space reg_assignment
		|	XRELEASE {vito_check("release");tp("release",$1.comment);} Print_space reg_lvalue
			;

procedural_timing_control_statement:
			delay_or_event_control {if (ai_process) tp(" ",NULL);} statement_or_null ;

delay_or_event_control:	delay_control
		|	{ ts_clear(); }
			event_control
			{  if(ai_process) {
			      /* verify that event matches RC_FILE's description */
			      if (strcmp(token_string,rc_string[ATEVENT])!=0) {
				 error("Event control ('%s') must match that given in file '%s' ('%s').\n",token_string,RCFILE,rc_string[ATEVENT]);
			      }
			   }
			}
			;

delay_control:		XPOUND {tp("#",$1.comment);} simple_delay_value
		|	XPOUND XLPAREN {tp("#",$1.comment);tp("(",$2.comment);} mintypmax_expression XRPAREN {tp(")",$5.comment);}
			;

event_control:		XAT {tp("@",$1.comment);} identifier
		|	XAT XLPAREN {tp("@",$1.comment);tp("(",$2.comment);} event_expression XRPAREN {tp(")",$5.comment);}
			;

event_expression:	event_term
		|	event_expression XOR {if (ai_process) tp(" or ",$2.comment); else tp("or",$2.comment);} event_term
			;

event_term:		expression
		|	XPOSEDGE {tp("posedge",$1.comment);if(ai_process)tp(" ",NULL);} expression
		|	XNEGEDGE {tp("negedge",$1.comment);if(ai_process)tp(" ",NULL);} expression
			;

conditional_statement:	XIF XLPAREN {tp("if",$1.comment);tp("(",$2.comment);} expression XRPAREN 
			{ tp(")",$5.comment); if(ai_process) tp("\nbegin\n",NULL); }
			statement_or_null
			{ if (ai_process) tp("end\n",NULL); }
			else_conditional
			;

else_conditional:	
		|	XELSE
			{ tp("else",$1.comment); if (ai_process) tp("\nbegin\n",NULL); }
			statement_or_null
			{ if (ai_process) tp("end\n",NULL); }
			;

case_statement:		case_keyword 
			XLPAREN 
			{if (ai_process) {
			   ts_clear();
			   new_token_print(PUT_NONE);
			}
			else
			   tp("(",$2.comment);} 
			expression 
			{if (ai_process) {
			   old_token_print();
			   case_push(&case_stack,Insert_ID(token_string,ts_length));
			}}
			XRPAREN 
			{if (!ai_process) {
			   tp(")",$6.comment);
			}}
			case_body
			XENDCASE 
			{if (ai_process)
			   case_pull(&case_stack);
			else
			   tp("endcase",$9.comment);
			}
			;

case_keyword:		XCASE {if (ai_process) warning("Case may not handle all cases correctly\n");else tp("case",$1.comment);}
		|	XCASEZ {vito_check("casez");if (!ai_process) tp("casez",$1.comment);}
		|	XCASEX {vito_check("casex");if (!ai_process) tp("casex",$1.comment);}
			;

case_body:		Mdefault_case_item simple_case_item Mcase_item
		|	Mdefault_case_item
			;

Mcase_item:		{insert_case_default(case_stack);}
		|	{if(ai_process)tp("else\nbegin\n",NULL);} simple_case_item Mcase_item {if (ai_process) tp("end\n",NULL);}
		|	default_case_item Mcase_item 
			;

case_item:		simple_case_item
		|	default_case_item
			;

simple_case_item:	{ if (ai_process) {
			   case_stack->no_items++;
			   tp("if(",NULL);
			}}
			Mcase_expression 
			XCOLON 
			{if (ai_process) 
			   tp(")\nbegin\n",NULL);
			else
			   tp(":",$2.comment);} 
			statement_or_null
			{if (ai_process) tp("end\n",NULL);}
			;

Mdefault_case_item:	
		|	Mdefault_case_item default_case_item
			;

default_case_item:	XDEFAULT 
			{if (ai_process) {
			   case_stack->no_items++;
			   if (!case_stack->found_default) {
			      fgetpos(out_file,&(case_stack->default_start));
			   }
			   else
			      new_token_print(PUT_NONE);
			}
			else
			   tp("default",$1.comment);} 
			Ocolon
			statement_or_null
			{if (ai_process)
			   if (!case_stack->found_default) {
			      case_stack->found_default=TRUE;
			      tp(CASE_DEFAULT_TERMINATOR,NULL);
			   }
			   else
			      old_token_print();
			}
			;

Ocolon:
		|	XCOLON {if (!ai_process) tp(":",$1.comment); }
			;

Mcase_expression:	case_expression
		|	Mcase_expression 
			XCOMMA 
			{if (ai_process)
			   tp("||",NULL);
			else
			   tp(",",$2.comment);} 
			case_expression
			;

case_expression:	{if(ai_process) {
			   tp("(",NULL);
			   tp(Get_ID(case_stack->expression),NULL);
			   tp(")==(",NULL);
			}}
			expression
			{if(ai_process)
			   tp(")",NULL);
			}
			;

loop_statement:		XFOREVER { tp("forever",$1.comment); if (ai_process) tp("\nbegin\n",NULL); }
			statement
			{if (ai_process) tp("end\n",NULL);}
		|	XREPEAT XLPAREN {tp("repeat",$1.comment);tp("(",$2.comment);vito_check("repeat");} expression XRPAREN 
			{tp(")",$5.comment); if (ai_process) tp("\nbegin\n",NULL);}
			statement
			{if (ai_process) tp("end\n",NULL);}
		|	XWHILE XLPAREN {tp("while",$1.comment);tp("(",$2.comment);} expression XRPAREN
			{tp(")",$5.comment); if (ai_process) tp("\nbegin\n",NULL);}
			statement
			{if(ai_process) tp("end\n",NULL);}
		|	XFOR XLPAREN {tp("for",$1.comment);tp("(",$2.comment);vito_check("for");} reg_assignment XSEMI {tp(";",$5.comment);} expression XSEMI {tp(";",$8.comment);} reg_assignment XRPAREN
			{tp(")",$11.comment); if (ai_process) tp("\nbegin\n",NULL);}
			statement
			{if (ai_process) tp("end\n",NULL);}
			;

reg_assignment:		reg_lvalue XEQUAL {tp("=",$2.comment);} expression
			;

wait_statement:		XWAIT 
			{  if (ai_process)
			      tp("while",$1.comment);
			   else
			      tp("wait",$1.comment);
			}
			XLPAREN 
			{tp("(",$3.comment);
			   if (ai_process)
			      tp("~(",NULL);} 
			expression
			XRPAREN
			{  tp(")",$6.comment);
			   if (ai_process)
			      tp(")\nbegin\n",NULL);}
			Print_newline
			statement_or_null
			{if(ai_process) tp("end\n",NULL);}
			;

event_trigger:		XEVENTTRIGGER {vito_check("->");tp("->",$1.comment);} identifier XSEMI {tp(";",$4.comment);} Print_newline
			;

disable_statement:	XDISABLE {tp("disable",$1.comment);if(ai_process)tp(" ",NULL);} identifier XSEMI {tp(";",$4.comment);} Print_newline ;

seq_block:		XBEGIN
			{ tp("",$1.comment); if (!ai_process) tp("begin",NULL); }
			Mstatement
			XEND
			{ tp("",$4.comment); if (!ai_process) tp("end",NULL); }
		|	XBEGIN
			XCOLON
			{ tp("begin",$1.comment);
			  tp(":",$2.comment);}
			identifier
			Print_newline
			Mblock_item_declaration
			Mstatement
			XEND
			{tp("end",$8.comment);}
			Print_newline
			;

par_block:		XFORK 
			{tp("fork",$1.comment);}
			Oblock_identifier
			Print_newline
			Mstatement_fork
			XJOIN
			{tp("join",$6.comment);}
			Print_newline
			;

Mstatement_fork:
		|	Mstatement_fork {if (ai_process) tp("begin\n",NULL);} statement {if (ai_process) tp("end\n",NULL);}
			;

Oblock_identifier:
		|	XCOLON {tp(":",$1.comment);}
			identifier
			Print_newline
			Mblock_item_declaration
			;

task_enable:		identifier XSEMI {vito_check("task call");tp(";",$2.comment);} Print_newline
		|	identifier XLPAREN {vito_check("task call");tp("(",$2.comment);} Mexpression XRPAREN XSEMI {tp(")",$5.comment);tp(";",$6.comment);} Print_newline
			;

system_task_enable:	system_task_name XSEMI {vito_check("task call");tp(";",$2.comment);} Print_newline
		|	system_task_name XLPAREN {vito_check("task call");tp("(",$2.comment);} Mst_expression XRPAREN XSEMI {tp(")",$5.comment);tp(";",$6.comment);} Print_newline
			;

system_task_name:	XDOLLAR {tp("$",$1.comment);} identifier ;

net_lvalue:		reg_lvalue 
			;

reg_lvalue:		identifier
		|	identifier XLSQUARE Print_lsquare expression XRSQUARE {tp("]",$5.comment);}
		|	identifier XLSQUARE Print_lsquare expression XCOLON {tp(":",$5.comment);}expression XRSQUARE {tp("]",$8.comment);
		/*	Should be the following (YACC won't accept):
		|	identifier XLSQUARE constant_expression XCOLON constant_expression XRSQUARE
		*/}
		|	concatenation
			;

Print_lsquare:		{tp("[",$0.comment);} ;

constant_expression:	constant_term
		|	constant_expression binary_operator constant_term
		|	constant_expression XQUESTION {tp("?",$2.comment);} constant_expression XCOLON {tp(":",$5.comment);} constant_term
			;

constant_term:		constant_primary
		|	unary_operator constant_primary
		|	string
			;
			
constant_primary:	number
		|	identifier
		|	concatenation
		|	multiple_concatenation
		|	XLPAREN {tp("(",$1.comment);} constant_mintypmax_expression XRPAREN {tp(")",$4.comment);}
			;

constant_mintypmax_expression:	constant_expression
		|	constant_expression XCOLON {tp(":",$2.comment);} constant_expression XCOLON {tp(":",$5.comment);} constant_expression
			;

mintypmax_expression:	expression
		|	expression XCOLON {tp(":",$2.comment);} expression XCOLON {tp(":",$5.comment);} expression
			;

Mexpression:		expression
		|	Mexpression XCOMMA {tp(",",$2.comment);} expression
			;

Mst_expression: 	{/* to allow for $display(x,,y)...*/}
		|	expression
		|	Mst_expression XCOMMA {tp(",",$2.comment);}
		|	Mst_expression XCOMMA {tp(",",$2.comment);} expression
			;

Oexpression:
		|	expression
			;

expression:		term
		|	expression binary_operator term
		|	expression XQUESTION {tp("?",$2.comment);} expression XCOLON {tp(":",$5.comment);} term
			;

term:			primary
		|	unary_operator primary
		|	string
			;
			
unary_operator:		XPLUS {tp("+",$1.comment);}
		|	XMINUS {tp("-",$1.comment);}
		|	XLNOT {tp("!",$1.comment);}
		|	XBNOT {tp("~",$1.comment);}
		|	XBAND {tp("&",$1.comment);}
		|	XBNAND {tp("~&",$1.comment);}
		|	XBOR {tp("|",$1.comment);}
		|	XBNOR {tp("~|",$1.comment);}
		|	XBXOR {tp("^",$1.comment);}
		|	XBXNOR {tp("~^",$1.comment);}
			;

binary_operator:	XPLUS {tp("+",$1.comment);}
		|	XMINUS {tp("-",$1.comment);}
		|	XMULT {tp("*",$1.comment);}
		|	XDIVIDE {tp("/",$1.comment);}
		|	XMOD {tp("%",$1.comment);}
		|	XLEQUAL {tp("==",$1.comment);}
		|	XLNOTEQUAL {tp("!=",$1.comment);}
		|	XCEQUAL {tp("===",$1.comment);}
		|	XCNOTEQUAL {tp("!==",$1.comment);}
		|	XLAND {tp("&&",$1.comment);}
		|	XLOR {tp("||",$1.comment);}
		|	XLESS {tp("<",$1.comment);}
		|	XLESSEQ {tp("<=",$1.comment);}
		|	XGREATER {tp(">",$1.comment);}
		|	XGREATEREQ {tp(">=",$1.comment);}
		|	XBAND {tp("&",$1.comment);}
		|	XBOR {tp("|",$1.comment);}
		|	XBXOR {tp("^",$1.comment);}
		|	XBXNOR {tp("~^",$1.comment);}
		|	XLSHIFT {tp("<<",$1.comment);}
		|	XRSHIFT {tp(">>",$1.comment);}
		|	XBNOR {tp("~|",$1.comment); /* not listed in T&M grammar! */ }
		|	XBNAND { tp("~&",$1.comment);/* not in T&M grammar */}
			;

primary:		number
		|	identifier
		|	identifier XLSQUARE Print_lsquare expression XRSQUARE {tp("]",$5.comment);}
		|	identifier XLSQUARE Print_lsquare expression XCOLON {tp(":",$5.comment);} expression XRSQUARE {tp("]",$8.comment);
		/*     should be the following (YACC won't accept):
		|	identifier XLSQUARE constant_expression XCOLON constant_expression XRSQUARE
		*/}
		|	concatenation
		|	multiple_concatenation
		|	function_call
		|	XLPAREN {tp("(",$1.comment);} mintypmax_expression XRPAREN {tp(")",$4.comment);}
			;

number:			XNUMBER {tp(Get_ID($1.identifier),$1.comment);} ;

unsigned_number:	XNUMBER {tp(Get_ID($1.identifier),$1.comment);} ;

concatenation:		XLBRACKET Print_lbracket Mexpression XRBRACKET {tp("}",$4.comment);};

multiple_concatenation:	XLBRACKET Print_lbracket expression XLBRACKET {tp("{",$4.comment);} Mexpression XRBRACKET {tp("}",$7.comment);} XRBRACKET {tp("}",$9.comment);};

Print_lbracket:		{tp("{",$0.comment);} ;

function_call:		identifier XLPAREN {tp("(",$2.comment);} Mexpression XRPAREN {tp(")",$5.comment);}
		|	name_of_system_function
		|	name_of_system_function XLPAREN {tp("(",$2.comment);} Mexpression XRPAREN {tp(")",$5.comment);}
			;

name_of_system_function: XDOLLAR {tp("$",$1.comment);} identifier 
		|	XDOLLAR {tp("$",$1.comment);} keyword 
			;

keyword:		XTIME {tp("time",$1.comment);}
			;

string:			XSTRING {tp(Get_ID($1.identifier),$1.comment);};

list_of_identifiers:	identifier
		|	list_of_identifiers XCOMMA {tp(",",$2.comment);} identifier
			;

identifier:		XIDENTIFIER {tp(Get_ID($1.identifier),$1.comment);} pidentifier ;

pidentifier:		
		|	pidentifier XPERIOD {tp(".",$2.comment);} XIDENTIFIER {tp(Get_ID($4.identifier),$4.comment);}
			;

%%
